import { type Ref } from 'vue';
export type Query = {
    url: string;
    method?: 'get' | 'post';
    data?: object;
};
export type Options = {
    manual?: boolean;
};
export type State<R, P> = {
    loading: Ref<boolean>;
    data: Ref<R | undefined>;
    error: Ref<Error | undefined>;
};
export interface QueryState<R, P> extends State<R, P> {
    run: (arg?: P) => Promise<R>;
}
declare function useRequest<R, P>(query: Query, options?: Options): QueryState<R, P>;
declare function request<R>(query: Query): Promise<R>;
export { useRequest, request };
